#!usr/bin/env python

#################  AutoMITAur.v1.0: A tool for de novo detection  of MITE ##################
#
# Main objective: de novo detection of MITE in sequenced genome
#
# Scientific contributors:  Aurelie Hua-Van
#
#
# Copyright 2013 Aurelie Hua-Van, ahuavan@legs.cnrs-gif.fr
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#
## SCIENTISTS: please be aware that the fact that this program is released
## as Free Software does not excuse you from scientific propriety, which
## obligates you to give appropriate credit! If you write a scientific paper
## describing research that made substantive use of this program, it is your
## obligation as a scientist to (a) mention the fashion in which this software
## was used, including the version number, with a citation to the literature,
## in the Methods section, to allow replication; and/or (b) mention this
## software in the Acknowledgements section.
#
#############################################################################

import re, sys, shutil, os, subprocess, shlex, time, glob,multiprocessing
from Bio import SeqIO

def align():
	
	quer=raw_input('Quels fichiers (*)? ').strip()
	doit(quer)
	
def doit(quer):
	#try:os.system('rm '+quer+'.mafft')
	#except TypeError:pass
	align=glob.glob(quer)
	nbcpu=multiprocessing.Pool(multiprocessing.cpu_count()) 
	nbcpu.map(eval('mafftor'), align)

def mafftor(clust):
	if len(open(clust).read().split('>')[1:])==1: # if 1 sequence, considered as already aligned (add.mafft)
		shutil.copyfile(clust,clust+'allafa')
		return clust
	else: 
	    os.system("mafft --reorder --quiet --retree 1 "+ clust+" > "+os.path.splitext(clust)[0]+'.allafa')
	
if __name__ == '__main__' : 

    if len(sys.argv)==2:doit(sys.argv[1])
    
    else: align()
else: 
    pass